module Hermes
  module RexClient
    class SyncStructuresTask

      def execute(client = Hermes::RexClient::Client.new, date)
        rex_last_updated = date || Setting.get_settings_for('rexclient').values['rex_last_updated']

        client.search_structures({'traceability.lastModifiedDate' => ">#{date}"}).each |rex_entity| do
          className = (rex_entity[:idEntityDefinition] == client.ed_entity) ? 'Hermes::Entity' : 'Hermes::Lessor'
          Hermes::RexCLient::UpdateStructureTask.execute(client, rex_entity, className)
        end
      end
    end
  end
end
